      program initwave
      implicit none
      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)
      call ismain ( nbuffr )

      end

c     --- Define boundary condition at outflow
c         sigmann = -p
c         p = rho g (1-y)

      function usfunb(ichois,x,y,z,t)
      implicit none
      integer ichois
      double precision usfunb,x,y,z,t
      double precision rho, g
      rho = 1
      g = 5.4
      if (ichois.eq.1) then
         usfunb=-rho*g*(1-y)
      end if
      end

c     --- Define initial condition for the pressure
c         p = rho g (1-y)

      function usfuni(ichois,x,y,z)
      implicit none
      integer ichois
      double precision usfuni,x,y,z
      double precision rho, g
      rho = 1
      g = 5.4
      if (ichois.eq.1) then
         usfuni=rho*g*(1-y)
      end if
      end
