      program intface
      implicit none

      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)

      call ismain( nbuffr )

      end

      function usfunc ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     coefficient as a function of space, time and previously computed
c     solutions.

      implicit none      

      integer ichoice
      double precision usfunc, x, y, z, t

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     t        i    actual time 
c     ichoice  i    choice parameter given by the user input
c     usfunc   o    computed coefficient

         if ( ichoice.eq.1 ) then
           if ( y.lt.12d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.12d-2 .and. x.le.88d-2 ) then
              usfunc = 10d3
             else if ( x.gt.88d-2 ) then
              usfunc = 10d-3
             end if
           else if ( y.ge.12d-2 .and. y.lt.38d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.12d-2 .and. x.lt.62d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.62d-2 .and. x.lt.88d-2 ) then
              usfunc = 1d0
             else if ( x.ge.88d-2 ) then
              usfunc = 10d-3
             end if
           else if ( y.ge.38d-2 .and. y.lt.62d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.12d-2 .and. x.lt.38d-2 ) then
              usfunc = 1d0
             else if ( x.ge.38d-2 .and. x.lt.62d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.62d-2 .and. x.lt.88d-2 ) then
              usfunc = 1d0
             else if ( x.ge.88d-2 ) then
              usfunc = 10d-3
             end if
           else if ( y.ge.62d-2 .and. y.lt.88d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.12d-2 .and. x.lt.38d-2 ) then
              usfunc = 1d0
             else if ( x.ge.38d-2 .and. x.lt.88d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.88d-2 ) then
              usfunc = 10d-3 
             end if
           else if ( y.ge.88d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.12d-2 .and. x.le.88d-2 ) then
              usfunc = 10d3
             else if ( x.gt.88d-2 ) then
              usfunc = 10d-3
             end if
           end if
         else if ( ichoice.eq.2 ) then
           if ( y.lt.12d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.12d-2 .and. x.le.88d-2 ) then
              usfunc = 10d-3
             else if ( x.gt.88d-2 ) then
              usfunc = 10d-3
             end if
           else if ( y.ge.12d-2 .and. y.lt.38d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d3
             else if ( x.ge.12d-2 .and. x.lt.62d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.62d-2 .and. x.lt.88d-2 ) then
              usfunc = 1d0
             else if ( x.ge.88d-2 ) then
              usfunc = 10d3
             end if
           else if ( y.ge.38d-2 .and. y.lt.62d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d3
             else if ( x.ge.12d-2 .and. x.lt.38d-2 ) then
              usfunc = 1d0
             else if ( x.ge.38d-2 .and. x.lt.62d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.62d-2 .and. x.lt.88d-2 ) then
              usfunc = 1d0
             else if ( x.ge.88d-2 ) then
              usfunc = 10d3
             end if
           else if ( y.ge.62d-2 .and. y.lt.88d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d3
             else if ( x.ge.12d-2 .and. x.lt.38d-2 ) then
              usfunc = 1d0
             else if ( x.ge.38d-2 .and. x.lt.88d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.88d-2 ) then
              usfunc = 10d3 
             end if
           else if ( y.ge.88d-2 ) then
             if ( x.lt.12d-2 ) then
              usfunc = 10d-3
             else if ( x.ge.12d-2 .and. x.le.88d-2 ) then
              usfunc = 10d-3
             else if ( x.gt.88d-2 ) then
              usfunc = 10d-3
             end if
           end if

         end if

      end

      subroutine usfilc ( ichois, coefs, ncoefs, icoef, ni, nj, nk,
     +                    ndim, nvirtual, coor, solut, ndegfd, t   )
c
c***********************************************************************
c
c     PSEUDO CODE    :
c
c
c***********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
cimp      implicit none      
c
      integer ichois, ncoefs, icoef, ni, nj, nk, ndim, nvirtual, ndegfd

      double precision coefs(1-nvirtual:ni+1+nvirtual,
     +                       1-nvirtual:nj+1+nvirtual,1:ncoefs),
     +                 coor(1-nvirtual:ni+1+nvirtual,
     +                      1-nvirtual:nj+1+nvirtual, 1:ndim),
     +                 solut(1-nvirtual:ni+1+nvirtual,
     +                       1-nvirtual:nj+1+nvirtual,
     +                       1:ndegfd, 1:2), t

c
c***********************************************************************
c
c                   LOCAL PARAMETERS
c
cimp      implicit none 

          integer ip, jp     
c
c
c***********************************************************************

        if ( ichois.eq.1 ) then

          do jp = 1, nj
            do ip = 1, ni

              coefs(ip,jp,3) = 0d0
              if ( ip.eq.13 .and. jp.eq.13 ) then
                 coefs(ip,jp,3) = 1d1
              else if ( ip.eq.25 .and. jp.eq.25 ) then
                 coefs(ip,jp,3) = 1d1
              else if ( ip.eq.38 .and. jp.eq.38 ) then
                 coefs(ip,jp,3) = 1d1
              end if

            end do
          end do

        end if

      end
