      program shocktube_nonconvex
c ======================================================================
c
c     programmer      Kees Kassels
c
c     version  1.0    date    25-03-1994
c
c   copyright (c) 1994  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c **********************************************************************
c
c                       DESCRIPTION
c
c     ISNaS Host Program
c
c **********************************************************************
c
c                       KEYWORDS
c
c     host_program
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
c **********************************************************************
c
c                       COMMON BLOCKS
c
      integer nbuffr
      parameter( nbuffr = 8000000 )
      integer ibuffr
      common ibuffr(nbuffr)
c

c     IBUFFR    Integer buffer array in which all array information
c               with respect to the ISNaS software is stored.
c     NBUFFR    Declared length of IBUFFR
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISHMAIN    ISNaS host main subroutine
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c          initialize local buffer
c          call ISNaS host main subroutine
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call ismain( nbuffr )

      end
      function usfuni (ichoice,x,y,z)
      implicit none
      integer ichoice
      double precision usfuni ,x ,y ,z,tollie
      tollie=1d-6
      if (ichoice.eq.1) then

c     --- ichoice =1 , p= pvapour-deltap, x<0 , p = pvapour+deltap, x>0

        if(x.gt.tollie) then
                  usfuni= 0.1d0
        else
            if(x.le.tollie.and.x.ge.-1d0*tollie) then
                usfuni= 0.6d0
            else
                usfuni= 1.1d0
            end if
        end if
      end if
      end
