      function isinisgl ( ipoint )
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.0    date   16-11-94(Extracted from the SEPRAN subroutine
c                                        inisgl version 1.0)
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c     Recompute pointer for buffer to pointer for ibuffr
c
c ********************************************************************
c
c                      KEYWORDS
c
c    memory_management
c    pointers
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer isinisgl, ipoint

c     ipoint    i    Address in array IBUFFR
c     isinisgl  o    Gives pointer in array IBUFFR corresponding to ipoint
c ********************************************************************
c
c                      COMMON BLOCKS
c
      include 'IScommon/cisnas'
c ********************************************************************
c
c                    LOCAL PARAMETERS
c
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c ********************************************************************
c
c                    I/O
c
c ********************************************************************
c
c                    ERROR MESSAGES
c
c ********************************************************************
c
c                    PSEUDO CODE
c
c ======================================================================
c
      if ( intlen.eq.1 ) then
         isinisgl = ipoint
      else
         isinisgl = (ipoint-1)*intlen+1
      end if
      end
