      program gravity_channel
      implicit none
      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)

      call ismain ( nbuffr )

      end


      function usfuni(ichois,x,y,z)

c     --- user subroutine to define the initial pressure
c         In this special example we set the pressure equal to the final
c         solution: p = rho g (1-y)

      implicit none
      integer ichois
      double precision usfuni,x,y,z
      double precision rho, g
      rho = 1
      g = 9.81
      if (ichois.eq.1) then
         usfuni=rho*g*(1-y)
      end if
      end


      function usfunb ( ichois, x, y, z, t )

c     --- user subroutine to define the normal stress = -p at the outflow
c         boundary
c         p = rho g (1-y)

      implicit none

      integer ichois
      double precision usfunb, x, y, z, t

      double precision rho, g
      rho = 1
      g = 9.81
      if (ichois.eq.1) then
         usfunb=-rho*g*(1-y)
      end if

      end
