      subroutine ispri200 ( realarr, text )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date   23-04-1996
c
c
c     copyright (c) 1996-1996  "TU-Delft"
c     permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "TU-Delft".
c     all rights reserved. no part of this publication may be reproduced,
c     stored in a retrieval system ( e.g., in memory, disk, or core)
c     or be transmitted by any means, electronic, mechanical, photocopy,
c     recording, or otherwise, without written permission from the
c     publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     Actual print os CPU time
c
c **********************************************************************
c
c                       KEYWORDS
c
c    print
c    time
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      double precision realarr(*)
      character *(*) text

c     realarr   i    Array of reals containing the reals that
c                    must be substituted in the print format.
c     text      i    String in which a text is stored
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisnas'
      include 'IScommon/cisparal'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       I/O
c
c     The output is printed to standard output
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      write(irefwr,100) text, realarr(1), realarr(2)
100   format(' CPU time used ',a39, 1x, f16.4,' seconds'/
     +       ' Cumulative CPU time used ',29x, f16.4,' seconds'  )

      if ( iblockrf.gt.0 ) write(irefwr,210) iblockrf
210   format(' Actual block number is ',i6/)

      end
