      subroutine prires(text,rnorm,icontr,final)
c ==================================================================
c
c
c     programmer
c     version          date
c
c
c ******************************************************************
c
c                       DESCRIPTION
c
c     This is an output subroutine. It prints the norm of the residual
c
c ******************************************************************
c
c                       KEYWORDS
c
c
c ******************************************************************
c
c                       INPUT / OUTPUT   PARAMETERS
c
cimp      implicit none
c
c
c ******************************************************************
c
c                       COMMON BLOCKS
c
c
c ******************************************************************
c
c                       LOCAL PARAMETERS
c
c ******************************************************************
c
c                       SUBROUTINES CALLED
c
c ******************************************************************
c
c                       I/O
c
c ******************************************************************
c
c                       ERROR MESSAGES
c
c ******************************************************************
c
c                       PSEUDO CODE
c
c ==================================================================
      character *6 text
      integer icontr(5)
      logical final
      double precision rnorm
      integer iter,iprint,ierr,iout
      iter = icontr(4)
      iprint = icontr(2)
      ierr = icontr(3)
      iout=icontr(5)
      if (iter .eq. 0) then
         if (iprint .gt. 0) write(iout,100) text
         if (iprint .eq. 1) write(iout,110) rnorm
         if (iprint .ge. 2) write(iout,120)
 100     format(//,' Output of subroutine ', a,// )
 110     format(' The 2-norm of the initial residual is:',ss,1pe13.4e2)
 120     format(' Iteration number  residual' //)
      end if
      if (iprint .ge. 2) write(iout,130) iter,rnorm
 130  format(i10,ss,1pe13.4e2)
      if (final) then
         if (iprint .ge. 0) then
            if (ierr .gt. 0) write(iout,140) text,iter,ierr
 140        format(//,a,' No convergence in ',i5,' iterations ',
     1             ' ierr= ',i2)
         end if
         if (iprint .ge. 1) write(iout,150) text,iter,rnorm
 150     format(' The number of executed iterations in ',a,
     1          ' is ',i5,/ ' The 2-norm of the residual is ',
     +            ss,1pe13.4e2)
      end if
      return
      end

